package view;

import javax.swing.*;
import java.awt.*;
import java.awt.event.ActionEvent;
import java.io.Serial;
import java.util.Enumeration;

public class StrategyPanel extends JPanel {
    @Serial
    private static final long serialVersionUID = 1L;

    public StrategyPanel() {
        JRadioButton strategy1 = new JRadioButton("Stratégie 1");
        JRadioButton strategy2 = new JRadioButton("Stratégie 2");

        ButtonGroup buttonGroup = new ButtonGroup();
        buttonGroup.add(strategy1);
        buttonGroup.add(strategy2);

        JButton confirmButton = new JButton("Confirmer");
        confirmButton.addActionListener((ActionEvent e) -> {
            // TODO - Appeler la bonne stratégie
            System.out.println(getSelectedButtonText(buttonGroup));
            // Fermer la fenêtre du component
            SwingUtilities.getWindowAncestor((Component) e.getSource()).dispose();
        });

        JButton cancelButton = new JButton("Annuler");
        cancelButton.addActionListener((ActionEvent e) -> {
            // Fermer la fenêtre du component
            SwingUtilities.getWindowAncestor((Component) e.getSource()).dispose();
        });

        add(strategy1);
        add(strategy2);
        add(confirmButton);
        add(cancelButton);
    }

    /**
     * Retourne le bouton sélectionné dans un groupe de boutons.
     *
     * @param buttonGroup
     * @return
     */
    public String getSelectedButtonText(ButtonGroup buttonGroup) {
        for (Enumeration<AbstractButton> buttons = buttonGroup.getElements(); buttons.hasMoreElements(); ) {
            AbstractButton button = buttons.nextElement();
            if (button.isSelected()) {
                return button.getText();
            }
        }

        return null;
    }
}
